<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="时间" prop="meetingTime">
        <el-date-picker clearable
                        v-model="queryParams.meetingTime"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="请选择时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="地点" prop="meetingVenue">
        <el-input v-model="queryParams.meetingVenue" placeholder="请输入地点" />
      </el-form-item>
      <el-form-item label="主要议题" prop="mainTopics">
        <el-input v-model="queryParams.mainTopics" placeholder="请输入主要议题" />
      </el-form-item>
      <el-form-item label="形成决议" prop="resolutionsFormed">
        <el-input v-model="queryParams.resolutionsFormed" placeholder="请输入形成决议" />
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input v-model="queryParams.remarks" placeholder="请输入备注" />
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:meeting:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:meeting:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:meeting:remove']"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--v-hasPermi="['branch:meeting:edit']"-->
        <!--&gt;导入</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:meeting:export']"-->
        <!--&gt;导出</el-button>-->
      <!--</el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="mgrList" @selection-change="handleSelectionChange"  :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="会议类型" align="center" prop="meetingType" :formatter="meetingTypeFormat" width="120"/>
      <el-table-column label="时间" align="center" prop="meetingTime" width="120">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.meetingTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="地点" align="center" prop="meetingVenue" width="120"/>
      <el-table-column label="主持人" align="center" prop="hostString" width="120"/>
      <el-table-column label="记录人" align="center" prop="recorderString" width="120"/>
      <el-table-column label="参加人员" align="center" prop="participantsString" width="120"/>
      <el-table-column label="缺席人员" align="center" prop="absenteesString" width="120"/>
      <el-table-column label="列席人员" align="center" prop="attendeesString" width="120"/>
      <el-table-column label="主要议题" align="left" prop="mainTopics" width="350"/>
      <el-table-column label="形成决议" align="left" prop="resolutionsFormed" width="350"/>
      <el-table-column label="备注" align="center" prop="remarks"/>
      <el-table-column label="附件" align="center" prop="filesId" width="100" fixed="right">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-folder"
            @click="openFileDialog(scope.row)"
          >查看附件
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="120" fixed="right">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:meeting:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:meeting:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改支部党员大会管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="会议类型" prop="meetingType">
          <el-select v-model="form.meetingType" placeholder="请选择会议类型">
            <el-option
              v-for="dict in meetingTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="时间" prop="meetingTime">
          <el-date-picker clearable
            v-model="form.meetingTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="请选择时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="地点" prop="meetingVenue">
          <el-input v-model="form.meetingVenue" placeholder="请输入地点" />
        </el-form-item>
        <el-form-item label="主持人" prop="host">
          <el-select v-model="form.host" multiple placeholder="请选择主持人">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="记录人" prop="recorder">
          <el-select v-model="form.recorder" multiple placeholder="请选择记录人">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="参加人员" prop="participants">
          <el-select v-model="form.participants" multiple placeholder="请选择参加人员">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="缺席人员" prop="absentees">
          <el-select v-model="form.absentees" multiple placeholder="请选择缺席人员">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="列席人员" prop="attendees">
          <el-select v-model="form.attendees" multiple placeholder="请选择列席人员">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="主要议题" prop="mainTopics">
          <el-input v-model="form.mainTopics" placeholder="请输入主要议题" type="textarea" rows="4"/>
        </el-form-item>
        <el-form-item label="形成决议" prop="resolutionsFormed">
          <el-input v-model="form.resolutionsFormed" placeholder="请输入形成决议" type="textarea" rows="4"/>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="归属部门" prop="deptId">
          <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 附件详情对话框 -->
    <el-dialog title="附件详情" :visible.sync="file.open" width="60%" append-to-body>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-upload
            ref="doc"
            :headers="doc.headers"
            :action="doc.url+'?tableName=branchMeeting&tableId=' + doc.tableId"
            :disabled="doc.isUploading"
            :on-progress="handleFileDocProgress"
            :on-success="handleFileDocSuccess"
            :auto-upload="true"
            :file-list="file.fileList"
          >
            <el-button type="primary"><i class="el-icon-upload"></i> 点击上传</el-button>
          </el-upload>
        </el-col>
      </el-row>
      <el-table :data="file.dataList">
        <el-table-column label="附件名称" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-document"
              @click="handleSee(scope.row.url)">
              {{ scope.row.name }}
            </el-button>
          </template>
        </el-table-column>
        <el-table-column label="上传人" align="center" prop="creater"/>
        <el-table-column label="上传时间" align="center" prop="createdate">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.createdate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteFile(scope.row.id)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>
  </div>
</template>

<script>
import { listMeeting, getMeeting, delMeeting, addMeeting, updateMeeting } from "@/api/branch/meeting";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { listUserNoPage } from "@/api/system/user";
import {delFile, listFile} from "../../../../api/branch/file";

export default {
  name: "Meeting",
  components: { Treeselect },
  data() {
    return {
      file: {
        id: null,
        open: false,
        fileList: [],
        dataList: [],
      },
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        tableId: 0,
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/branch/file/uploadFile",
      },
      clientHeight:300,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 支部党员大会管理表格数据
      mgrList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        meetingId: null,
        meetingType: null,
        meetingTime: null,
        meetingVenue: null,
        host: null,
        recorder: null,
        participants: null,
        absentees: null,
        attendees: null,
        mainTopics: null,
        resolutionsFormed: null,
        remarks: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        meetingType: [
          { required: true, message: "会议类型不能为空", trigger: "blur" }
        ],
        meetingTime: [
          { required: true, message: "时间不能为空", trigger: "blur" }
        ],
        meetingVenue: [
          { required: true, message: "地点不能为空", trigger: "blur" }
        ],
        deptId: [
          { required: true, message: "归属部门不能为空", trigger: "blur" }
        ],
      },
      // 会议类型字典
      meetingTypeOptions: [],
      // 部门树选项
      deptOptions: [],
      // 用户列表
      userList: [],
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight -250
    })
    this.getList();
    this.getTreeselect();
    this.getDicts("meeting_type").then(response => {
      this.meetingTypeOptions = response.data;
    });
  },
  methods: {//附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      console.log(response.data, '-----', this.file.id);
      this.$modal.msgSuccess("上传成功");
      this.getFileList();
    },
    handleSee(url) {
      window.open(process.env.VUE_APP_BASE_API + url);
    },
    openFileDialog(row) {
      console.log(row)
      this.file.open = true;
      this.doc.tableId = row.meetingId;
      this.getFileList();
    },
    getFileList() {
      listFile({tableId: this.doc.tableId, tableName: 'branchMeeting'}).then(res => {
        this.file.dataList = res.data
      })
    },
    handleDeleteFile(id) {
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delFile(id);
      }).then(() => {
        this.getFileList();
        this.msgSuccess("删除成功");
      })
    },
    /** 查询用户列表 */
    getUserList() {
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for(let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = { "dictValue" : rows[i].userId, "dictLabel" : rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 会议类型字典翻译
    meetingTypeFormat(row, column) {
      return this.selectDictLabel(this.meetingTypeOptions, row.meetingType);
    },
    /** 查询支部党员大会管理列表 */
    getList() {
      this.loading = true;
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for(let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = { "dictValue" : rows[i].userId, "dictLabel" : rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
        this.queryParams.meetingType = "2";
        listMeeting(this.queryParams).then(response => {
          this.mgrList = response.rows;
          for (let i = 0; i < this.mgrList.length; i++) {
            if (this.mgrList[i].host != null) {
              let host = this.mgrList[i].host.split(",");
              let hostString = "";
              for (let j = 0; j < host.length; j++) {
                if (j > 0) {
                  hostString += "、" + this.selectDictLabel(this.userList, host[j]);
                } else {
                  hostString += this.selectDictLabel(this.userList, host[j]);
                }
              }
              this.mgrList[i].hostString = hostString;
            }
            if (this.mgrList[i].recorder != null) {
              let recorder = this.mgrList[i].recorder.split(",");
              let recorderString = "";
              for (let j = 0; j < recorder.length; j++) {
                if (j > 0) {
                  recorderString += "、" + this.selectDictLabel(this.userList, recorder[j]);
                } else {
                  recorderString += this.selectDictLabel(this.userList, recorder[j]);
                }
              }
              this.mgrList[i].recorderString = recorderString;
            }
            if (this.mgrList[i].participants != null) {
              let participants = this.mgrList[i].participants.split(",");
              let participantsString = "";
              for (let j = 0; j < participants.length; j++) {
                if (j > 0) {
                  participantsString += "、" + this.selectDictLabel(this.userList, participants[j]);
                } else {
                  participantsString += this.selectDictLabel(this.userList, participants[j]);
                }
              }
              this.mgrList[i].participantsString = participantsString;
            }
            if (this.mgrList[i].absentees != null) {
              let absentees = this.mgrList[i].absentees.split(",");
              let absenteesString = "";
              for (let j = 0; j < absentees.length; j++) {
                if (j > 0) {
                  absenteesString += "、" + this.selectDictLabel(this.userList, absentees[j]);
                } else {
                  absenteesString += this.selectDictLabel(this.userList, absentees[j]);
                }
              }
              this.mgrList[i].absenteesString = absenteesString;
            }
            if (this.mgrList[i].attendees != null) {
              let attendees = this.mgrList[i].attendees.split(",");
              let attendeesString = "";
              for (let j = 0; j < attendees.length; j++) {
                if (j > 0) {
                  attendeesString += "、" + this.selectDictLabel(this.userList, attendees[j]);
                } else {
                  attendeesString += this.selectDictLabel(this.userList, attendees[j]);
                }
              }
              this.mgrList[i].attendeesString = attendeesString;
            }
          }
          this.total = response.total;
          this.loading = false;
        });
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        meetingId: null,
        meetingType: null,
        meetingTime: null,
        meetingVenue: null,
        host: null,
        recorder: null,
        participants: null,
        absentees: null,
        attendees: null,
        mainTopics: null,
        resolutionsFormed: null,
        remarks: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.meetingId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.form.meetingType = "2";
      this.title = "添加支部党员大会";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const meetingId = row.meetingId || this.ids
      getMeeting(meetingId).then(response => {
        this.form = response.data;
        if (this.form.host != null) {
          this.form.host = this.form.host.split(",").map(Number);
        }
        if (this.form.recorder != null) {
          this.form.recorder = this.form.recorder.split(",").map(Number);
        }
        if (this.form.participants != null) {
          this.form.participants = this.form.participants.split(",").map(Number);
        }
        if (this.form.absentees != null) {
          this.form.absentees = this.form.absentees.split(",").map(Number);
        }
        if (this.form.attendees != null) {
          this.form.attendees = this.form.attendees.split(",").map(Number);
        }
        this.open = true;
        this.title = "修改支部党员大会";
      });
    },
    /** 提交按钮 */
    submitForm() {
      if (this.form.host != null) {
        this.form.host = this.form.host.join();
      }
      if (this.form.recorder != null) {
        this.form.recorder = this.form.recorder.join();
      }
      if (this.form.participants != null) {
        this.form.participants = this.form.participants.join();
      }
      if (this.form.absentees != null) {
        this.form.absentees = this.form.absentees.join();
      }
      if (this.form.attendees != null) {
        this.form.attendees = this.form.attendees.join();
      }
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.meetingId != null) {
            updateMeeting(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMeeting(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const meetingIds = row.meetingId || this.ids;
      this.$modal.confirm('是否确认删除支部党员大会编号为"' + meetingIds + '"的数据项？').then(function() {
        return delMeeting(meetingIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/mgr/export', {
        ...this.queryParams
      }, `mgr_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
<style>
  /** 文本换行符处理 */
  .el-table .cell{
    white-space: pre-wrap;
  }
  /** textarea字体 */
  textarea {
  font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
  }
</style>
